import javax.swing.*;
import java.awt.*;
import java.awt.Graphics;
import java.awt.event.ActionListener;
import java.util.*;

public class FormCruiser{
    private DrawingCruiser _drawingCruiser;
    Canvas canv;
    public void Draw(){
        canv.repaint();
    }
    public FormCruiser(){
        JFrame frame = new JFrame("Cruiser");
        JButton buttonCreate = new JButton("Создать");
        buttonCreate.setFocusPainted(false);
        buttonCreate.setContentAreaFilled(false);
        JButton buttonUp = new JButton();
        buttonUp.setFocusPainted(false);
        buttonUp.setContentAreaFilled(false);
        buttonUp.setName("up");
        buttonUp.setIcon(new ImageIcon(((new ImageIcon("src/Images/totop.png")).getImage()).getScaledInstance(35, 35, java.awt.Image.SCALE_SMOOTH)));
        JButton buttonDown = new JButton();
        buttonDown.setFocusPainted(false);
        buttonDown.setContentAreaFilled(false);
        buttonDown.setName("down");
        buttonDown.setIcon(new ImageIcon(((new ImageIcon("src/Images/todown.png")).getImage()).getScaledInstance(35, 35, java.awt.Image.SCALE_SMOOTH)));
        JButton buttonLeft = new JButton();
        buttonLeft.setFocusPainted(false);
        buttonLeft.setContentAreaFilled(false);
        buttonLeft.setName("left");
        buttonLeft.setIcon(new ImageIcon(((new ImageIcon("src/Images/toleft.png")).getImage()).getScaledInstance(35, 35, java.awt.Image.SCALE_SMOOTH)));
        JButton buttonRight = new JButton();
        buttonRight.setFocusPainted(false);
        buttonRight.setContentAreaFilled(false);
        buttonRight.setName("right");
        buttonRight.setIcon(new ImageIcon(((new ImageIcon("src/Images/toright.png")).getImage()).getScaledInstance(35, 35, java.awt.Image.SCALE_SMOOTH)));
        buttonCreate.addActionListener(
                e -> {
                    System.out.println(e.getActionCommand());
                    Random random = new Random();
                    _drawingCruiser = new DrawingCruiser();
                    _drawingCruiser.Init(
                            random.nextInt(200) + 100,
                            random.nextInt(2000) + 1000,
                            new Color(random.nextInt(256), random.nextInt(256), random.nextInt(256)),
                            random.nextBoolean(), random.nextBoolean());
                    _drawingCruiser.SetPosition(random.nextInt(100-30+1)+30, //начальные и конечные значения для рандома
                            random.nextInt(90-20+1)+20 //начальные и конечные значения для рандома
                            ,this.canv.getWidth(), this.canv.getHeight());
                    canv._drawingCruiser = _drawingCruiser;
                    Draw();
                }
        );
        ActionListener actionListener = e -> {
            if (_drawingCruiser == null){
                return;
            }
            switch ((((JButton)(e.getSource())).getName())){
                case "up":
                    _drawingCruiser.MoveTransport(Direction.Up);
                    break;
                case "down":
                    _drawingCruiser.MoveTransport(Direction.Down);
                    break;
                case "left":
                    _drawingCruiser.MoveTransport(Direction.Left);
                    break;
                case "right":
                    _drawingCruiser.MoveTransport(Direction.Right);
                    break;
            }
            Draw();
        };
        buttonUp.addActionListener(actionListener);
        buttonDown.addActionListener(actionListener);
        buttonLeft.addActionListener(actionListener);
        buttonRight.addActionListener(actionListener);
        frame.setSize(910, 500);
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setLayout(null);
        canv = new Canvas();
        canv.setBounds(0, 0, 895, 500 - 40); // 40 - const, высота панели сверху
        buttonCreate.setBounds(20, 420, 100, 40);
        buttonUp.setBounds(800, 380, 40, 40);
        buttonDown.setBounds(800, 420, 40, 40);
        buttonLeft.setBounds(760, 420, 40, 40);
        buttonRight.setBounds(840, 420, 40, 40);
        frame.add(canv);
        frame.add(buttonCreate);
        frame.add(buttonUp);
        frame.add(buttonDown);
        frame.add(buttonLeft);
        frame.add(buttonRight);
        frame.setVisible(true);
    }
    class Canvas extends JComponent{
        public DrawingCruiser _drawingCruiser;
        public Canvas(){}

        public void paintComponent(Graphics g){
            if (_drawingCruiser == null){
                return;
            }
            super.paintComponents(g);
            Graphics2D g2d = (Graphics2D)g;
            _drawingCruiser.DrawTransport(g2d);
            super.repaint();
        }
    }
}